; *********************************************************************
; *                                                                   *
; *     Komunikacna kniznica wDbg pomocov kniznice wBus               *
; *     Napisal: Vladimir Visnovsky                                   *
; *                                                                   *
; *********************************************************************

.Include "wBus.asm"

; Procedury textoveho interface
; - dbgInit
; - dbgClrScr
; - dbgLine [Byte, alebo A : Riadok]
; - dbgText [Word: AdresaFlash konciaci nulov]
; - dbgHex  [Byte, alebo A]
; - dbgBin  [Byte, alebo A]
; - dbgDec  [Byte, alebo A]
; Ladenie
; - dbgStop
; - dbgPoint [Byte]
; - dbgError [Byte]
; - dbgInfo
; - dbginfoHL

Rjmp dbgEndOfFile

.Macro dbg_Init
 bs_Init
 bs_Instruction
 bs_SendByte ['l']
 bs_SendByte [3] 
 bs_Instruction
 bs_SendByte ['s']
 Address [Text_Init]
 bs_SendFromFlash  
 bs_Reset 
.EndMacro

; Debug symboly
; - l 0-3 	- Riadok
; - c 		- Zmazat obrazovku
; - s		- Text
; - h,d,b 	- Cislo
.Macro dbgClrScr
  bs_Instruction
  bs_SendByte ['c'] 
.EndMacro
.Macro dbgLine
  Push A
  bs_Instruction
  bs_SendByte ['l']
  Pop A
  bs_SendByte 
.EndMacro
.Macro dbgLine_i
  bs_Instruction
  bs_SendByte ['l']
  bs_SendByte [ @0 ] 
.EndMacro
.Macro dbgText
 .message "dbgText: Chyba parameter textu"
.EndMacro
.Macro dbgText_i
  bs_Instruction
  bs_SendByte ['s']
  Address [@0]
  bs_SendFromFlash  
  bs_Reset
.EndMacro
.Macro dbgHex
 Push A
 bs_Instruction
 bs_SendByte ['h']
 Pop A 
 bs_SendByte
.EndMacro
.Macro dbgHex_i
 bs_Instruction
 bs_SendByte ['h']
 bs_SendByte [@0]
.EndMacro
.Macro dbgBin
 Push A
 bs_Instruction
 bs_SendByte ['b']
 Pop A 
 bs_SendByte
.EndMacro
.Macro dbgBin_i
 bs_Instruction
 bs_SendByte ['b']
 bs_SendByte [@0]
.EndMacro
.Macro dbgDec
 Push A
 bs_Instruction
 bs_SendByte ['d']
 Pop A 
 bs_SendByte
.EndMacro
.Macro dbgDec_i
 bs_Instruction
 bs_SendByte ['d']
 bs_SendByte [@0]
.EndMacro
.Macro dbgStop
 dbg_Stop_%1:
 Rjmp dbg_Stop_%1
.EndMacro 
 
; Procedury ladenia
; - Point
 adbg_Point:
  Push A
  bs_Reset
  ; Zmazanie obrazovky
  dbgLine [0]
  ; Odoslanie retazca
  dbgText [Text_Point]
  ; odoslanie dekadickeho cisla
  Pop A
  dbgDec
  Ret
; - Error
 adbg_Error:
  Push A
  bs_Reset
  ; Zmazanie obrazovky
  dbgLine [1] 
  ; Odoslanie retazca
  dbgText [Text_Chyba]
  ; odoslanie dekadickeho cisla
  Pop A
  dbgDec
  Ret
 .Macro dbgPoint
  Rcall adbg_Point
 .EndMacro
 .Macro dbgPoint_i
  Acc [@0]
  Rcall adbg_Point
 .EndMacro
 .Macro dbgError
  Rcall adbg_Error
 .EndMacro
 .Macro dbgError_i
  Acc [@0]
  Rcall adbg_Error
 .EndMacro

; Vypis registrov
 adbg_RegInfo:
  Push A
  bs_Reset
  ; Odoslanie retazca
  bs_Instruction
  bs_SendByte ['s'] 
  Mov A   , B
  bs_SendByte 
  bs_SendByte [58]
  bs_SendByte [' ']
  bs_Reset
  ; Odoslanie hexu
  Pop A
  Push A 
  dbgHex
  ; Odoslanie h  
  bs_Instruction
  bs_SendByte ['s'] 
  bs_SendByte ['h']
  bs_SendByte [' ']
  bs_Reset
  ; odoslanie v Bin 
  Pop A
  Push A 
  dbgBin
  ; Odoslanie h  
  bs_Instruction
  bs_SendByte ['s'] 
  bs_SendByte ['b']
  bs_SendByte [' ']
  bs_Reset
  ; Odoslanie v Dec
  Pop A
  Push A 
  dbgDec
  Pop A
  Ret
 .Macro dbg_Info
  Rcall adbg_RegInfo
 .EndMacro

; Vypis viac 8 bit registrov
.Macro dbgInfo
 adbg_regInfo8:
  Push ZL
  Push ZH
  Push A
  Push B
  Push T
  Push A
  bs_Reset
  ; Zmazanie obrazovky
 ; dbgClrScr
  dbgLine [0]
  ; Vypis textu
  dbgText [Text_vreg]
  ; Prvy riadok
  dbgLine [ 1 ]
  ; Vypis A  
  Ldi B		, 'A'
  Pop A
  dbg_Info
  ; Druhy riadok
  dbgLine [ 2 ]
  ; Vypis B 
  Ldi B		, 'B'
  Pop T
  Pop A
  Push A
  Push T
  dbg_Info
  ; Treti riadok
  dbgLine [ 3 ]
  ; Vypis T 
  Ldi B		, 'T'
  Pop A
  Push A
  dbg_Info
  ;Koniec
  Pop T
  Pop B
  Pop A
  Pop ZH
  Pop ZL
  Ret
.EndMacro

; Vypis viac 8 bit registrov
.Macro dbgInfoHL
 adbg_regInfo8_HL:
  Push ZL
  Push ZH
  Push A
  Push B
  Push T
  Push A
  bs_Reset
  ; Zmazanie obrazovky
 ; dbgClrScr
  dbgLine [0]
  ; Vypis textu
  dbgText [Text_vreg]
  ; Prvy riadok
  dbgLine [ 1 ]
  ; Vypis A  
  Ldi B		, 'A'
  Pop A
  dbg_Info
  ; Druhy riadok
  dbgLine [ 2 ]
  ; Vypis H 
  Ldi B		, 'H'
  Mov A		, H
  dbg_Info
  ; Treti riadok
  dbgLine [ 3 ]
  ; Vypis L 
  Ldi B		, 'L'
  Mov A		, L
  dbg_Info
  ;Koniec
  Pop T
  Pop B
  Pop A
  Pop ZH
  Pop ZL
  Ret
.EndMacro

; Vypis pamate
.Macro dbgMemInfo
 Push T
 Push A
 Push B
 ; Vycistit obrazovku
; dbgClrScr
 ; Vypis prvych 10
 Ldi B	, 10
 MyLoop1_%:
  Ld A	, Z+
  dbgHex 
  Dec B
  Brne MyLoop1_% 
 ; Vypis 10
 dbgLine [1]
 Ldi B	, 10
 MyLoop2_%:
  Ld A	, Z+
  dbgHex 
  Dec B
  Brne MyLoop2_% 
 ; Vypis 10
 dbgLine [2]
 Ldi B	, 10
 MyLoop3_%:
  Ld A	, Z+
  dbgHex 
  Dec B
  Brne MyLoop3_% 
 ; Vypis 10
 dbgLine [3]
 Ldi B	, 10
 MyLoop4_%:
  Ld A	, Z+
  dbgHex 
  Dec B
  Brne MyLoop4_% 
 ; koniec 
 Pop B 
 Pop A
 Pop T
.EndMacro 
 
adbg_info:
 dbgInfo
 ret
.Macro dbg_reg
 Rcall adbg_info
.EndMacro    
  
; Texty
Text_Point:
 .db "Point: ",0
Text_vReg:
 .db "Vypis registrov",0
Text_Chyba:
 .db "Chyba: ",0 
Text_init:
 .db "wDbg pripojeny     ",0 
 .db "wBus Interface init",0 

dbgEndOfFile:
